diff -urN sbcl-0.8.16/src/code/run-program.lisp sbcl-0.8.16.patched/src/code/run-program.lisp
--- sbcl-0.8.16/src/code/run-program.lisp	2003-09-01 12:41:25.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/run-program.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -289,12 +289,12 @@
 (defun find-a-pty ()
   (dolist (char '(#\p #\q))
     (dotimes (digit 16)
-      (let* ((master-name (format nil "/dev/pty~C~X" char digit))
+      (let* ((master-name (coerce (format nil "/dev/pty~C~X" char digit) 'base-string))
 	     (master-fd (sb-unix:unix-open master-name
 					   sb-unix:o_rdwr
 					   #o666)))
 	(when master-fd
-	  (let* ((slave-name (format nil "/dev/tty~C~X" char digit))
+	  (let* ((slave-name (coerce (format nil "/dev/tty~C~X" char digit) 'base-string))
 		 (slave-fd (sb-unix:unix-open slave-name
 					      sb-unix:o_rdwr
 					      #o666)))
@@ -347,7 +347,9 @@
 	(declare (simple-string s))
 	(let ((n (length s)))
 	  ;; Blast the string into place.
-	  (sb-kernel:copy-to-system-area (the simple-string s)
+	  (sb-kernel:copy-to-system-area (the simple-base-string
+                                           ;; FIXME
+                                           (coerce s 'simple-base-string))
 					 (* sb-vm:vector-data-offset
 					    sb-vm:n-word-bits)
 					 string-sap 0
@@ -382,6 +384,7 @@
 ;;; Is UNIX-FILENAME the name of a file that we can execute?
 (defun unix-filename-is-executable-p (unix-filename)
   (declare (type simple-string unix-filename))
+  (setf unix-filename (coerce unix-filename 'base-string))
   (values (and (eq (sb-unix:unix-file-kind unix-filename) :file)
 	       (sb-unix:unix-access unix-filename sb-unix:x_ok))))
 
@@ -614,7 +617,7 @@
 ;;; stream.
 (defun copy-descriptor-to-stream (descriptor stream cookie)
   (incf (car cookie))
-  (let ((string (make-string 256))
+  (let ((string (make-string 256 :element-type 'base-char))
 	handler)
     (setf handler
 	  (sb-sys:add-fd-handler
@@ -683,7 +686,7 @@
 	 ;; Use /dev/null.
 	 (multiple-value-bind
 	       (fd errno)
-	     (sb-unix:unix-open "/dev/null"
+	     (sb-unix:unix-open #.(coerce "/dev/null" 'base-string)
 				(case direction
 				  (:input sb-unix:o_rdonly)
 				  (:output sb-unix:o_wronly)
@@ -735,7 +738,7 @@
 	    (dotimes (count
 		       256
 		      (error "could not open a temporary file in /tmp"))
-	      (let* ((name (format nil "/tmp/.run-program-~D" count))
+	      (let* ((name (coerce (format nil "/tmp/.run-program-~D" count) 'base-string))
 		     (fd (sb-unix:unix-open name
 					    (logior sb-unix:o_rdwr
 						    sb-unix:o_creat
diff -urN sbcl-0.8.16/src/code/seq.lisp sbcl-0.8.16.patched/src/code/seq.lisp
--- sbcl-0.8.16/src/code/seq.lisp	2004-10-06 08:22:31.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/seq.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -569,6 +569,14 @@
   (when (null source-end) (setq source-end (length source-sequence)))
   (mumble-replace-from-mumble))
 
+(defun simple-character-string-replace-from-simple-character-string*
+    (target-sequence source-sequence
+     target-start target-end source-start source-end)
+  (declare (type (simple-array character (*)) target-sequence source-sequence))
+  (when (null target-end) (setq target-end (length target-sequence)))
+  (when (null source-end) (setq source-end (length source-sequence)))
+  (mumble-replace-from-mumble))
+
 (define-sequence-traverser replace
     (sequence1 sequence2 &key start1 end1 start2 end2)
   #!+sb-doc
diff -urN sbcl-0.8.16/src/code/stream.lisp sbcl-0.8.16.patched/src/code/stream.lisp
--- sbcl-0.8.16/src/code/stream.lisp	2004-08-10 13:16:15.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/stream.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -276,11 +276,11 @@
 #!-sb-fluid (declaim (inline ansi-stream-unread-char))
 (defun ansi-stream-unread-char (character stream)
   (let ((index (1- (ansi-stream-in-index stream)))
-        (buffer (ansi-stream-in-buffer stream)))
+        (buffer (ansi-stream-cin-buffer stream)))
     (declare (fixnum index))
     (when (minusp index) (error "nothing to unread"))
     (cond (buffer
-           (setf (aref buffer index) (char-code character))
+           (setf (aref buffer index) character)
            (setf (ansi-stream-in-index stream) index))
           (t
            (funcall (ansi-stream-misc stream) stream
@@ -418,7 +418,7 @@
 ;;; the IN-BUFFER for text streams. There is definitely an IN-BUFFER,
 ;;; and hence must be an N-BIN method.
 (defun fast-read-char-refill (stream eof-error-p eof-value)
-  (let* ((ibuf (ansi-stream-in-buffer stream))
+  (let* ((ibuf (ansi-stream-cin-buffer stream))
 	 (count (funcall (ansi-stream-n-bin stream)
 			 stream
 			 ibuf
@@ -433,16 +433,17 @@
 	   (funcall (ansi-stream-in stream) stream eof-error-p eof-value))
 	  (t
 	   (when (/= start +ansi-stream-in-buffer-extra+)
+	     ;; FIXME AARGH KLUDGE There's no sb!vm:n-character-bits.
 	     (bit-bash-copy ibuf (+ (* +ansi-stream-in-buffer-extra+
-				       sb!vm:n-byte-bits)
+				       sb!vm:n-byte-bits 4)
 				    (* sb!vm:vector-data-offset
 				       sb!vm:n-word-bits))
-			    ibuf (+ (the index (* start sb!vm:n-byte-bits))
+			    ibuf (+ (the index (* start sb!vm:n-byte-bits 4))
 				    (* sb!vm:vector-data-offset
 				       sb!vm:n-word-bits))
-			    (* count sb!vm:n-byte-bits)))
+			    (* count sb!vm:n-byte-bits 4)))
 	   (setf (ansi-stream-in-index stream) (1+ start))
-	   (code-char (aref ibuf start))))))
+	   (aref ibuf start)))))
 
 ;;; This is similar to FAST-READ-CHAR-REFILL, but we don't have to
 ;;; leave room for unreading.
@@ -1028,7 +1029,7 @@
 	     (:include string-stream
 		       (in #'string-inch)
 		       (bin #'ill-bin)
-		       (n-bin #'string-stream-read-n-bytes)
+		       (n-bin #'ill-bin)
 		       (misc #'string-in-misc)
                        (string (missing-arg) :type simple-string))
 	     (:constructor internal-make-string-input-stream
@@ -1233,14 +1234,19 @@
 	 (element-type (string-output-stream-element-type stream))
 	 (result 
 	  (case element-type
-	    ;; Overwhelmingly common case; can be inlined.
+	    ;; overwhelmingly common case: can be inlined
 	    ((character) (make-string length))
+	    ;; slightly less common cases: inline it anyway
+	    ((base-char standard-char)
+	     (make-string length :element-type 'base-char))
 	    (t (make-string length :element-type element-type)))))
     ;; For the benefit of the REPLACE transform, let's do this, so
     ;; that the common case isn't ludicrously expensive.
     (etypecase result 
       ((simple-array character (*)) 
        (replace result (string-output-stream-string stream)))
+      (simple-base-string
+       (replace result (string-output-stream-string stream)))
       ((simple-array nil (*))
        (replace result (string-output-stream-string stream))))
     (setf (string-output-stream-index stream) 0
@@ -1263,6 +1269,8 @@
 ;;; the CLM, but they are required for the implementation of
 ;;; WITH-OUTPUT-TO-STRING.
 
+;;; FIXME: need to support (VECTOR BASE-CHAR) and (VECTOR NIL),
+;;; ideally without destroying all hope of efficiency.
 (deftype string-with-fill-pointer ()
   '(and (vector character)
 	(satisfies array-has-fill-pointer-p)))
@@ -1292,9 +1300,9 @@
 	(if (= offset-current end)
 	    (let* ((new-length (1+ (* current 2)))
 		   (new-workspace (make-string new-length)))
-	      (declare (simple-string new-workspace))
-	      (%byte-blt workspace start
-			 new-workspace 0 current)
+	      (declare (type (simple-array character (*)) new-workspace))
+              (replace new-workspace workspace
+                       :start2 start :end2 offset-current)
 	      (setf workspace new-workspace
 		    offset-current current)
 	      (set-array-header buffer workspace new-length
@@ -1322,21 +1330,16 @@
 	    (let* ((new-length (+ (the fixnum (* current 2)) string-len))
 		   (new-workspace (make-string new-length)))
 	      (declare (type (simple-array character (*)) new-workspace))
-	      (%byte-blt workspace dst-start
-			 new-workspace 0 current)
-	      (setf workspace new-workspace)
-	      (setf offset-current current)
-	      (setf offset-dst-end dst-end)
-	      (set-array-header buffer
-				workspace
-				new-length
-				dst-end
-				0
-				new-length
-				nil))
+              (replace new-workspace workspace
+                       :start2 dst-start :end2 offset-current)
+	      (setf workspace new-workspace
+                    offset-current current
+                    offset-dst-end dst-end)
+	      (set-array-header buffer workspace new-length
+				dst-end 0 new-length nil))
 	    (setf (fill-pointer buffer) dst-end))
-	(%byte-blt string start
-		   workspace offset-current offset-dst-end)))
+	(replace workspace string
+                 :start1 offset-current :start2 start :end2 end)))
     dst-end))
 
 (defun fill-pointer-misc (stream operation &optional arg1 arg2)
@@ -1399,7 +1402,7 @@
 	(indentation (indenting-stream-indentation ,stream)))
        ((>= i indentation))
      (%write-string
-      "							    "
+      #.(make-string 60 :initial-element #\Space)
       ,sub-stream
       0
       (min 60 (- indentation i)))))
@@ -1472,12 +1475,12 @@
   #!+sb-doc
   "Return a stream that sends all output to the stream TARGET, but modifies
    the case of letters, depending on KIND, which should be one of:
-     :upcase - convert to upper case.
-     :downcase - convert to lower case.
-     :capitalize - convert the first letter of words to upper case and the
-	rest of the word to lower case.
-     :capitalize-first - convert the first letter of the first word to upper
-	case and everything else to lower case."
+     :UPCASE - convert to upper case.
+     :DOWNCASE - convert to lower case.
+     :CAPITALIZE - convert the first letter of words to upper case and the
+        rest of the word to lower case.
+     :CAPITALIZE-FIRST - convert the first letter of the first word to upper
+        case and everything else to lower case."
   (declare (type stream target)
 	   (type (member :upcase :downcase :capitalize :capitalize-first)
 		 kind)
@@ -1525,7 +1528,7 @@
 
 (defun case-frob-upcase-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1550,7 +1553,7 @@
 
 (defun case-frob-downcase-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1583,7 +1586,7 @@
 
 (defun case-frob-capitalize-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1628,7 +1631,7 @@
 
 (defun case-frob-capitalize-aux-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1673,7 +1676,7 @@
 
 (defun case-frob-capitalize-first-sout (stream str start end)
   (declare (type case-frob-stream stream)
-	   (type simple-base-string str)
+	   (type simple-string str)
 	   (type index start)
 	   (type (or index null) end))
   (let* ((target (case-frob-stream-target stream))
@@ -1742,8 +1745,7 @@
        (with-array-data ((data seq) (offset-start start) (offset-end end))
          (typecase data
 	   ((or (simple-array (unsigned-byte 8) (*))
-		(simple-array (signed-byte 8) (*))
-		simple-string)
+		(simple-array (signed-byte 8) (*)))
 	    (let* ((numbytes (- end start))
 		   (bytes-read (read-n-bytes stream data offset-start
 					     numbytes nil)))
diff -urN sbcl-0.8.16/src/code/sysmacs.lisp sbcl-0.8.16.patched/src/code/sysmacs.lisp
--- sbcl-0.8.16/src/code/sysmacs.lisp	2003-10-25 23:34:36.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/sysmacs.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -105,7 +105,7 @@
 (defmacro prepare-for-fast-read-char (stream &body forms)
   `(let* ((%frc-stream% ,stream)
 	  (%frc-method% (ansi-stream-in %frc-stream%))
-	  (%frc-buffer% (ansi-stream-in-buffer %frc-stream%))
+	  (%frc-buffer% (ansi-stream-cin-buffer %frc-stream%))
 	  (%frc-index% (ansi-stream-in-index %frc-stream%)))
      (declare (type index %frc-index%)
 	      (type ansi-stream %frc-stream%))
@@ -126,7 +126,7 @@
      (prog1 (fast-read-char-refill %frc-stream% ,eof-error-p ,eof-value)
 	    (setq %frc-index% (ansi-stream-in-index %frc-stream%))))
     (t
-     (prog1 (code-char (aref %frc-buffer% %frc-index%))
+     (prog1 (aref %frc-buffer% %frc-index%)
 	    (incf %frc-index%)))))
 
 ;;;; And these for the fasloader...
diff -urN sbcl-0.8.16/src/code/target-c-call.lisp sbcl-0.8.16.patched/src/code/target-c-call.lisp
--- sbcl-0.8.16/src/code/target-c-call.lisp	2003-03-29 14:03:42.000000000 +0100
+++ sbcl-0.8.16.patched/src/code/target-c-call.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -35,10 +35,14 @@
 (define-alien-type-translator void ()
   (parse-alien-type '(values) (sb!kernel:make-null-lexenv)))
 
+;;; FIXME: %NATURALIZE-C-STRING (and the UTF8 siblings below) would
+;;; appear to be vulnerable to the lisp string moving from underneath
+;;; them if the world undergoes a GC, possibly triggered by another
+;;; thread.  Ugh.
 (defun %naturalize-c-string (sap)
   (declare (type system-area-pointer sap))
   (locally
-      (declare (optimize (speed 3) (safety 0)))
+    (declare (optimize (speed 3) (safety 0)))
     (let ((length (loop for offset of-type fixnum upfrom 0
                         until (zerop (sap-ref-8 sap offset))
                         finally (return offset))))
@@ -48,3 +52,98 @@
                                                    sb!vm:n-word-bits)
                                          (* length sb!vm:n-byte-bits))
 	result))))
+
+(defun %naturalize-utf8-string (sap)
+  (declare (type system-area-pointer sap))
+  (locally
+    (declare (optimize (speed 3) (safety 0)))
+    (let ((length (do* ((offset 0)
+                        (byte (sap-ref-8 sap offset) (sap-ref-8 sap offset))
+                        (index 0 (1+ index)))
+                       ((zerop byte) index)
+                    (declare (type fixnum offset index))
+                    (cond
+                      ;; FIXME: Here, and below, we don't defend
+                      ;; against malformed utf-8 with any degree of
+                      ;; rigour.
+                      ((< byte #x80) (incf offset))
+                      ((< byte #xe0) (incf offset 2))
+                      ((< byte #xf0) (incf offset 3))
+                      (t (incf offset 4))))))
+      (let ((result (make-string length :element-type 'character)))
+        (do* ((offset 0)
+              (byte (sap-ref-8 sap offset) (sap-ref-8 sap offset))
+              (index 0 (1+ index)))
+            ((>= index length) result)
+          (declare (type fixnum offset index))
+          (setf (char result index)
+                (cond
+                  ((< byte #x80)
+                   (prog1 (code-char byte) (incf offset)))
+                  ((< byte #xe0)
+                   (prog1 (code-char (dpb byte (byte 5 6)
+                                          (sap-ref-8 sap (1+ offset))))
+                     (incf offset 2)))
+                  ((< byte #xf0)
+                   (prog1 (code-char
+                           (dpb byte (byte 4 12)
+                                (dpb (sap-ref-8 sap (1+ offset)) (byte 6 6)
+                                     (sap-ref-8 sap (+ 2 offset)))))
+                     (incf offset 3)))
+                  (t
+                   (prog1
+                       (code-char
+                        (dpb byte (byte 3 18)
+                             (dpb (sap-ref-8 sap (1+ offset)) (byte 6 12)
+                                  (dpb (sap-ref-8 sap (+ 2 offset)) (byte 6 6)
+                                       (sap-ref-8 sap (+ 3 offset))))))
+                     (incf offset 4))))))))))
+
+(defun %deport-utf8-string (string)
+  (declare (type simple-string string))
+  (locally
+    (declare (optimize (speed 3) (safety 0)))
+    (let ((length (1+ (do* ((offset 0)
+                            (length (length string))
+                            (index 0 (1+ index)))
+                           ((= index length) offset)
+                        (declare (type fixnum offset))
+                        (let ((bits (char-code (char string index))))
+                          (cond
+                            ((< bits #x80) (incf offset 1))
+                            ((< bits #x800) (incf offset 2))
+                            ((< bits #x10000) (incf offset 3))
+                            (t (incf offset 4))))))))
+      (let ((vector (make-array length :element-type '(unsigned-byte 8)
+                                :initial-element 0)))
+        (do* ((offset 0)
+              (length (length string))
+              (index 0 (1+ index)))
+             ((= index length) vector)
+          (declare (type fixnum offset))
+          (let ((bits (char-code (char string index))))
+            (cond
+              ((< bits #x80)
+               (setf (aref vector offset) bits)
+               (incf offset))
+              ((< bits #x800)
+               (setf (aref vector offset) (logior #xc0 (ldb (byte 5 6) bits)))
+               (setf (aref vector (1+ offset))
+                     (logior #x80 (ldb (byte 6 0) bits)))
+               (incf offset 2))
+              ((< bits #x10000)
+               (setf (aref vector offset) (logior #xe0 (ldb (byte 4 12) bits)))
+               (setf (aref vector (1+ offset))
+                     (logior #x80 (ldb (byte 6 6) bits)))
+               (setf (aref vector (+ offset 2))
+                     (logior #x80 (ldb (byte 6 0) bits)))
+               (incf offset 3))
+              (t
+               (setf (aref vector offset) (logior #xf0 (ldb (byte 3 18) bits)))
+               (setf (aref vector (1+ offset))
+                     (logior #x80 (ldb (byte 6 12) bits)))
+               (setf (aref vector (+ offset 2))
+                     (logior #x80 (ldb (byte 6 6) bits)))
+               (setf (aref vector (+ offset 3))
+                     (logior #x80 (ldb (byte 6 0) bits)))
+               (incf offset 4)))))))))
diff -urN sbcl-0.8.16/src/code/target-char.lisp sbcl-0.8.16.patched/src/code/target-char.lisp
--- sbcl-0.8.16/src/code/target-char.lisp	2004-01-20 19:10:23.000000000 +0100
+++ sbcl-0.8.16.patched/src/code/target-char.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -32,6 +32,27 @@
 (deftype char-code ()
   `(integer 0 (,char-code-limit)))
 
+(defvar *character-database*)
+
+(macrolet ((frob ()
+             (with-open-file (stream (merge-pathnames
+                                      (make-pathname
+                                       :directory
+                                       '(:relative :up :up "output")
+                                       :name "ucd"
+                                       :type "dat")
+                                      sb!xc:*compile-file-pathname*)
+                                     :direction :input
+                                     :element-type '(unsigned-byte 8))
+               (let* ((length (file-length stream))
+                      (array (make-array length
+                                         :element-type '(unsigned-byte 8))))
+                 (read-sequence array stream)
+                 `(defun !character-database-cold-init ()
+		    (setq *character-database* ',array))))))
+  (frob))
+#+sb-xc-host (!character-database-cold-init)
+
 ;;; This is the alist of (character-name . character) for characters
 ;;; with long names. The first name in this list for a given character
 ;;; is used on typeout and is the preferred form for input.
@@ -40,8 +61,10 @@
 	       (dolist (code char-names-list)
 		 (destructuring-bind (ccode names) code
 		   (dolist (name names)
-		     (results (cons name (code-char ccode))))))
-	       `(defparameter *char-name-alist* ',(results)))))
+		     (results (cons name ccode)))))
+	       `(defparameter *char-name-alist*
+                 (mapcar (lambda (x) (cons (car x) (code-char (cdr x))))
+                         ',(results))))))
   ;; Note: The *** markers here indicate character names which are
   ;; required by the ANSI specification of #'CHAR-NAME. For the others,
   ;; we prefer the ASCII standard name.
@@ -78,15 +101,76 @@
 	 (#x1E ("Rs" "^^"))
 	 (#x1F ("Us" "^_"))
 	 (#x20 ("Space" "Sp")) ; *** See Note above.
-	 (#x7f ("Rubout" "Delete" "Del"))))) ; *** See Note above.
+	 (#x7f ("Rubout" "Delete" "Del"))
+	 (#x80 ("C80"))
+	 (#x81 ("C81"))
+	 (#x82 ("Break-Permitted"))
+	 (#x83 ("No-Break-Permitted"))
+	 (#x84 ("C84"))
+	 (#x85 ("Next-Line"))
+	 (#x86 ("Start-Selected-Area"))
+	 (#x87 ("End-Selected-Area"))
+	 (#x88 ("Character-Tabulation-Set"))
+	 (#x89 ("Character-Tabulation-With-Justification"))
+	 (#x8A ("Line-Tabulation-Set"))
+	 (#x8B ("Partial-Line-Forward"))
+	 (#x8C ("Partial-Line-Backward"))
+	 (#x8D ("Reverse-Linefeed"))
+	 (#x8E ("Single-Shift-Two"))
+	 (#x8F ("Single-Shift-Three"))
+	 (#x90 ("Device-Control-String"))
+	 (#x91 ("Private-Use-One"))
+	 (#x92 ("Private-Use-Two"))
+	 (#x93 ("Set-Transmit-State"))
+	 (#x94 ("Cancel-Character"))
+	 (#x95 ("Message-Waiting"))
+	 (#x96 ("Start-Guarded-Area"))
+	 (#x97 ("End-Guarded-Area"))
+	 (#x98 ("Start-String"))
+	 (#x99 ("C99"))
+	 (#x9A ("Single-Character-Introducer"))
+	 (#x9B ("Control-Sequence-Introducer"))
+	 (#x9C ("String-Terminator"))
+	 (#x9D ("Operating-System-Command"))
+	 (#x9E ("Privacy-Message"))
+	 (#x9F ("Application-Program-Command"))))) ; *** See Note above.
 
 ;;;; accessor functions
 
+;; (* 8 186) => 1488
+;; (+ 1488 (ash #x110000 -8)) => 5840
+(defun ucd-index (char)
+  (let* ((cp (char-code char))
+	 (cp-high (ash cp -8))
+	 (page (aref *character-database* (+ 1488 cp-high))))
+    (+ 5840 (ash page 10) (ash (ldb (byte 8 0) cp) 2))))
+
+(defun ucd-value-0 (char)
+  (aref *character-database* (ucd-index char)))
+
+(defun ucd-value-1 (char)
+  (let ((index (ucd-index char)))
+    (dpb (aref *character-database* (+ index 3))
+	 (byte 8 16)
+	 (dpb (aref *character-database* (+ index 2))
+	      (byte 8 8)
+	      (aref *character-database* (1+ index))))))
+
+(defun ucd-general-category (char)
+  (aref *character-database* (* 8 (ucd-value-0 char))))
+
+(defun ucd-decimal-digit (char)
+  (let ((decimal-digit (aref *character-database*
+			     (+ 3 (* 8 (ucd-value-0 char))))))
+    (when (< decimal-digit 10)
+      decimal-digit)))
+
 (defun char-code (char)
   #!+sb-doc
   "Return the integer code of CHAR."
+  ;; FIXME: do we actually need this?
   (etypecase char
-    (base-char (char-code (truly-the base-char char)))))
+    (character (char-code (truly-the character char)))))
 
 (defun char-int (char)
   #!+sb-doc
@@ -156,41 +240,34 @@
   "The argument must be a character object. GRAPHIC-CHAR-P returns T if the
   argument is a printing character (space through ~ in ASCII), otherwise
   returns NIL."
-  (and (typep char 'base-char)
-       (< 31
-	  (char-code (the base-char char))
-	  127)))
+  (let ((n (char-code char)))
+    (or (< 31 n 127)
+	(< 159 n))))
 
 (defun alpha-char-p (char)
   #!+sb-doc
   "The argument must be a character object. ALPHA-CHAR-P returns T if the
    argument is an alphabetic character, A-Z or a-z; otherwise NIL."
-  (let ((m (char-code char)))
-    (or (< 64 m 91) (< 96 m 123))))
+  (< (ucd-general-category char) 5))
 
 (defun upper-case-p (char)
   #!+sb-doc
   "The argument must be a character object; UPPER-CASE-P returns T if the
    argument is an upper-case character, NIL otherwise."
-  (< 64
-     (char-code char)
-     91))
+  (= (ucd-value-0 char) 0))
 
 (defun lower-case-p (char)
   #!+sb-doc
   "The argument must be a character object; LOWER-CASE-P returns T if the
    argument is a lower-case character, NIL otherwise."
-  (< 96
-     (char-code char)
-     123))
+  (= (ucd-value-0 char) 1))
 
 (defun both-case-p (char)
   #!+sb-doc
   "The argument must be a character object. BOTH-CASE-P returns T if the
   argument is an alphabetic character and if the character exists in
   both upper and lower case. For ASCII, this is the same as ALPHA-CHAR-P."
-  (let ((m (char-code char)))
-    (or (< 64 m 91) (< 96 m 123))))
+  (< (ucd-value-0 char) 2))
 
 (defun digit-char-p (char &optional (radix 10.))
   #!+sb-doc
@@ -208,14 +285,17 @@
 	  ;; Also check lower case a - z.
 	  ((and (>= (setq m (- m 32)) 10) (< m radix)) m)
 	  ;; Else, fail.
-	  (t nil))))
+	  (t (let ((number (ucd-decimal-digit char)))
+	       (when (and number (< number radix))
+		 number))))))
 
 (defun alphanumericp (char)
   #!+sb-doc
   "Given a character-object argument, ALPHANUMERICP returns T if the
    argument is either numeric or alphabetic."
-  (let ((m (char-code char)))
-    (or (< 47 m 58) (< 64 m 91) (< 96 m 123))))
+  (let ((gc (ucd-general-category char)))
+    (or (< gc 5)
+	(= gc 12))))
 
 (defun char= (character &rest more-characters)
   #!+sb-doc
@@ -279,8 +359,11 @@
 ;;;  which loses font, bits, and case info.
 
 (defmacro equal-char-code (character)
-  `(let ((ch (char-code ,character)))
-     (if (< 96 ch 123) (- ch 32) ch)))
+  (let ((ch (gensym)))
+    `(let ((,ch ,character))
+      (if (= (ucd-value-0 ,ch) 0)
+	  (ucd-value-1 ,ch)
+	  (char-code ,ch)))))
 
 (defun char-equal (character &rest more-characters)
   #!+sb-doc
@@ -354,16 +437,17 @@
 
 (defun char-upcase (char)
   #!+sb-doc
-  "Return CHAR converted to upper-case if that is possible."
-  (if (lower-case-p char)
-      (code-char (- (char-code char) 32))
+  "Return CHAR converted to upper-case if that is possible.  Don't convert
+   lowercase eszet (U+DF)."
+  (if (= (ucd-value-0 char) 1)
+      (code-char (ucd-value-1 char))
       char))
 
 (defun char-downcase (char)
   #!+sb-doc
   "Return CHAR converted to lower-case if that is possible."
-  (if (upper-case-p char)
-      (code-char (+ (char-code char) 32))
+  (if (= (ucd-value-0 char) 0)
+      (code-char (ucd-value-1 char))
       char))
 
 (defun digit-char (weight &optional (radix 10))
diff -urN sbcl-0.8.16/src/code/target-format.lisp sbcl-0.8.16.patched/src/code/target-format.lisp
--- sbcl-0.8.16/src/code/target-format.lisp	2004-10-20 10:15:30.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/target-format.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -76,8 +76,11 @@
 	   (multiple-value-bind (new-directives new-args)
 	       (let* ((character (format-directive-character directive))
 		      (function
-		       (svref *format-directive-interpreters*
-			      (char-code character)))
+                       (typecase character
+                         (base-char 
+                          (svref *format-directive-interpreters*
+                                 (char-code character)))
+                         (character nil)))
 		      (*default-format-error-offset*
 		       (1- (format-directive-end directive))))
 		 (unless function
@@ -835,7 +838,7 @@
 		(setf args (nthcdr posn orig-args))
 		(error 'format-error
 		       :complaint "Index ~W is out of bounds. (It should ~
-				   have been between 0 and ~W.)"
+                                   have been between 0 and ~W.)"
 		       :args (list posn (length orig-args))))))
       (if colonp
 	  (interpret-bind-defaults ((n 1)) params
@@ -848,7 +851,7 @@
 		       (error 'format-error
 			      :complaint
 			      "Index ~W is out of bounds. (It should 
-			       have been between 0 and ~W.)"
+                               have been between 0 and ~W.)"
 			      :args
 			      (list new-posn (length orig-args))))))))
 	  (interpret-bind-defaults ((n 1)) params
diff -urN sbcl-0.8.16/src/code/target-load.lisp sbcl-0.8.16.patched/src/code/target-load.lisp
--- sbcl-0.8.16/src/code/target-load.lisp	2004-09-09 14:10:14.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/target-load.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -80,14 +80,20 @@
 			       :element-type '(unsigned-byte 8))
 	 (load-as-fasl stream verbose print)))
       (t
-       (let ((first-line (with-open-file (stream truename :direction :input)
-			   (read-line stream nil)))
-	     (fhsss *fasl-header-string-start-string*))
+       (let* ((fhsss *fasl-header-string-start-string*)
+	      (first-line (make-array (length fhsss)
+				      :element-type '(unsigned-byte 8)))
+	      (read-length
+	       (with-open-file (stream truename
+				       :direction :input
+				       :element-type '(unsigned-byte 8))
+		 (read-sequence first-line stream))))
 	 (cond
-	  ((and first-line
-		(>= (length (the simple-string first-line))
-		    (length fhsss))
-		(string= first-line fhsss :end1 (length fhsss)))
+	   ((and (= read-length (length fhsss))
+		 (do ((i 0 (1+ i)))
+		     ((= i read-length) t)
+		   (when (/= (char-code (aref fhsss i)) (aref first-line i))
+		     (return))))
 	   (internal-load pathname truename if-does-not-exist verbose print
 			  :binary))
 	  (t
@@ -126,7 +132,7 @@
 	     (> (file-write-date src-tn) (file-write-date obj-tn)))
 	(restart-case
 	 (error "The object file ~A is~@
-		older than the presumed source:~%  ~A."
+                 older than the presumed source:~%  ~A."
 		(namestring obj-tn)
 		(namestring src-tn))
 	 ;; FIXME: In CMU CL one of these was a CONTINUE case.
@@ -289,4 +295,9 @@
 (defun !loader-cold-init ()
   (/show0 "/!loader-cold-init")
   (dolist (routine *!initial-assembler-routines*)
-    (setf (gethash (car routine) *assembler-routines*) (cdr routine))))
+    (setf (gethash (car routine) *assembler-routines*) (cdr routine)))
+  (dolist (symbol *!initial-foreign-symbols*)
+    (setf (gethash (car symbol) *static-foreign-symbols*) (cdr symbol))))
+
+(declaim (ftype (function (string) (unsigned-byte #.sb!vm:n-machine-word-bits))
+		foreign-symbol-address-as-integer))
diff -urN sbcl-0.8.16/src/code/target-package.lisp sbcl-0.8.16.patched/src/code/target-package.lisp
--- sbcl-0.8.16/src/code/target-package.lisp	2004-07-04 15:03:27.000000000 +0200
+++ sbcl-0.8.16.patched/src/code/target-package.lisp	2004-10-26 17:08:22.000000000 +0200
@@ -550,7 +550,7 @@
   #!+sb-doc
   "Changes the name and nicknames for a package."
   (let* ((package (find-undeleted-package-or-lose package))
-	 (name (string name))
+	 (name (package-namify name))
 	 (found (find-package name))
 	 (nicks (mapcar #'string nicknames)))
     (unless (or (not found) (eq found package))
@@ -850,7 +850,7 @@
 	       :package package
 	       :format-control
 	       "Exporting these symbols from the ~A package:~%~S~%~
-	        results in name conflicts with these packages:~%~{~A ~}"
+                results in name conflicts with these packages:~%~{~A ~}"
 	       :format-arguments
 	       (list (package-%name package) cset
 		     (mapcar #'package-%name cpackages)))
@@ -953,7 +953,7 @@
 		 :package package
 		 :format-control
 		 "Importing these symbols into the ~A package ~
-		causes a name conflict:~%~S"
+                  causes a name conflict:~%~S"
 		 :format-arguments (list (package-%name package) cset))))
       ;; Add the new symbols to the internal hashtable.
       (let ((internal (package-internal-symbols package)))
